Bug 1267516 (CVE-2015-5286) - CVE-2015-5286 openstack-glance: Storage overrun by deleting images
Summary: CVE-2015-5286 openstack-glance: Storage overrun by deleting images
Keywords:
Status: CLOSED ERRATA
Alias: CVE-2015-5286
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard:
Depends On: 1268208 1268209 1269275 1269276 1269277 1269278
Blocks: 1263515 1267518
TreeView+ depends on / blocked
 
Reported: 2015-09-30 09:10 UTC by Adam Mariš
Modified: 2019-09-29 13:37 UTC (History)
27 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
A race-condition flaw was discovered in the OpenStack Image service (glance). When images in the upload state were deleted using a token close to expiration, untracked image data could accumulate in the back end. Because untracked data does not count towards the storage quota, an attacker could use this flaw to cause a denial of service through resource exhaustion.
Clone Of:
: 1272824 (view as bug list)
Environment:
Last Closed: 2015-10-15 21:40:36 UTC


Attachments (Terms of Use)
Master patch (6.83 KB, patch)
2015-09-30 09:12 UTC, Adam Mariš
no flags Details | Diff
Stable/juno patch (7.09 KB, patch)
2015-09-30 09:12 UTC, Adam Mariš
no flags Details | Diff
Stable/kilo patch (7.02 KB, patch)
2015-09-30 09:13 UTC, Adam Mariš
no flags Details | Diff


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2015:1897 normal SHIPPED_LIVE Moderate: openstack-glance security update 2015-10-15 16:29:01 UTC

Description Adam Mariš 2015-09-30 09:10:08 UTC
A vulnerability in openstack-glance allowing malicous user to cause DoS was reported. By deleting images that are being uploaded using a token that is about to expire, a malicious user can overcome the storage quota and accumulate untracked image data in the backend resulting in potential resource exhaustion and denial of service. All Glance setups using the V1 API are affected and all setups using the V2 API with the registry db_api enabled are affected.

Affects: <=2014.2.3, >=2015.1.0, <=2015.1.1

Comment 1 Adam Mariš 2015-09-30 09:12:30 UTC
Created attachment 1078568 [details]
Master patch

Comment 2 Adam Mariš 2015-09-30 09:12:59 UTC
Created attachment 1078569 [details]
Stable/juno patch

Comment 3 Adam Mariš 2015-09-30 09:13:21 UTC
Created attachment 1078570 [details]
Stable/kilo patch

Comment 6 Tristan Cacqueray 2015-10-01 17:23:54 UTC
Not that it's now public upstream and proposed patch missed a fix for import task API V2: https://review.openstack.org/#/q/Ia6e1fe0d27b13b920ee7e728feb5305dec77e066,n,z

Comment 7 Tristan Cacqueray 2015-10-01 17:24:18 UTC
s/Not/Note/

Comment 8 Martin Prpič 2015-10-02 07:28:25 UTC
Public via:

https://bugs.launchpad.net/glance/+bug/1498163

Comment 9 Martin Prpič 2015-10-02 07:31:09 UTC
Created openstack-glance tracking bugs for this issue:

Affects: openstack-rdo [bug 1268208]
Affects: fedora-all [bug 1268209]

Comment 10 Tristan Cacqueray 2015-10-02 13:38:30 UTC
Martin, attachments were correct, it just that this need an extra set of patch to fully address this CVE.

You can preview the upcoming advisory (including all required changes review url) here: https://review.openstack.org/#/c/229950/2/ossa/OSSA-2015-020.yaml

Comment 11 Flavio Percoco 2015-10-05 04:23:37 UTC
Hi, I think we are missing BZs for OSP5/OSP6/OSP7 ?

Comment 12 Martin Prpič 2015-10-05 15:10:57 UTC
(In reply to Tristan Cacqueray from comment #10)
> Martin, attachments were correct, it just that this need an extra set of
> patch to fully address this CVE.
> 
> You can preview the upcoming advisory (including all required changes review
> url) here: https://review.openstack.org/#/c/229950/2/ossa/OSSA-2015-020.yaml

Ah, ok, I thought the ones you linked to were meant to replace the old ones.

(In reply to Flavio Percoco from comment #11)
> Hi, I think we are missing BZs for OSP5/OSP6/OSP7 ?

These will be filed as soon as we're done with the analysis of this issue. Stay tuned!

Comment 14 Summer Long 2015-10-15 00:09:16 UTC
Acknowledgements:

Red Hat would like to thank the OpenStack project for reporting this issue. Upstream acknowledges Mike Fedosin and Alexei Galkin of Mirantis as the original reporters.

Comment 15 errata-xmlrpc 2015-10-15 12:33:25 UTC
This issue has been addressed in the following products:

  OpenStack 5 for RHEL 6
  OpenStack 5 for RHEL 7
  OpenStack 6 for RHEL 7
  OpenStack 7 For RHEL 7

Via RHSA-2015:1897 https://rhn.redhat.com/errata/RHSA-2015-1897.html


Note You need to log in before you can comment on or make changes to this bug.